/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.opennebula.client;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.xpath.XPathFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.xml.sax.SAXException;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;

/**
 *
 * @author tsbatista
 */
public abstract class XmlElement {

    private Element xml;

    protected void setXml(Element xml) {
        this.xml = xml;
    }

    protected void buildXml(String xmlString) {
        try {
            DocumentBuilder builder;
            Document doc;
            //Element         xml;

            builder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
            doc = builder.parse(
                    new ByteArrayInputStream(xmlString.getBytes()));
            xml = doc.getDocumentElement();
        } catch (ParserConfigurationException e) {
            Logger.getLogger(User.class.getName()).log(Level.SEVERE, null, e);
        } catch (SAXException e) {
            Logger.getLogger(User.class.getName()).log(Level.SEVERE, null, e);
        } catch (IOException e) {
            Logger.getLogger(User.class.getName()).log(Level.SEVERE, null, e);
        }
    }

    protected String xpath(String path) {
        XPath localxpath = XPathFactory.newInstance().newXPath();
        try {
            return localxpath.evaluate(path, xml);
        } catch (XPathExpressionException ex) {
            Logger.getLogger(XmlElement.class.getName()).log(Level.SEVERE, null, ex);
            throw new RuntimeException(ex);
        }
    }
}
